L11. Subarray with k different integers | 2 Pointers and Sliding Window Playlist

  Рет қаралды 53,562

take U forward

take U forward

Күн бұрын

Пікірлер: 96
@takeUforward
@takeUforward 7 ай бұрын
There is a slight mistake in the code. Please find the fix below while (mpp.size() > k) { mpp[nums[l]]--; if (mpp[nums[l]] == 0) mpp.erase(nums[l]); l++; } The while condition and the value of L
@ManishKumar-dk8hl
@ManishKumar-dk8hl 7 ай бұрын
👍
@rainyvideo6936
@rainyvideo6936 2 ай бұрын
@karthik-varma-1579
@karthik-varma-1579 Ай бұрын
Java Code class Solution { public int subarraysWithKDistinct(int[] nums, int k) { return subArraysLessThanEqualToK(nums,k)-subArraysLessThanEqualToK(nums,k-1); } public int subArraysLessThanEqualToK(int[] nums,int k){ int l=0,r=0,count=0; HashMap hm = new HashMap(); while(r k){ int rm = nums[l]; hm.put(rm,hm.get(rm)-1); if(hm.get(rm) == 0){ hm.remove(rm); } l++; } count += (r-l); r++; } return count; } }
@pranjuljaiswal1974
@pranjuljaiswal1974 23 күн бұрын
its working fine int n=arr.length,l=0,r=0,count=0; HashMap map = new HashMap(); while(r k){ map.put(arr[l],map.getOrDefault(arr[l],0)-1); if(map.get(arr[l]) == 0) map.remove(arr[l]); l++; } count+=(r-l+1); r++; } return count;
@rohitn8883
@rohitn8883 8 ай бұрын
Hey Striver, I think there are two corrections needed to be done the while condition should be while (mp.size() > k) and instead of l-1, it should be incremented to l+1
@priyanshkumar17
@priyanshkumar17 7 ай бұрын
Thanks!!
@aritralahiri8321
@aritralahiri8321 7 ай бұрын
You're right
@abhishekrao4853
@abhishekrao4853 7 ай бұрын
you are correct
@gajananbodhankar1963
@gajananbodhankar1963 7 ай бұрын
Agree 💯
@manasranjandas3108
@manasranjandas3108 Ай бұрын
yes
@yogeshinba6809
@yogeshinba6809 7 ай бұрын
Solved this on my own using learnings from previous lectures, thanks striver :)
@tarunyadav6617
@tarunyadav6617 3 ай бұрын
fr , just using
@AdityaSingh-uy8ms
@AdityaSingh-uy8ms 7 ай бұрын
The explanation of the problem and its solutions from basic to optimized solutions... everything is crystal clear ... truely helpful ... thanks
@soumyajit_0
@soumyajit_0 7 ай бұрын
3 Corrections. 1) The inner while condition should be while(mp.size>k) 2) The l=l-1 should be l=l+1 in the inner loop.
@Dsa_kabaap
@Dsa_kabaap 6 ай бұрын
1 correction. 1). U mentioned 3 but listed 2
@pruthvinarayana9568
@pruthvinarayana9568 2 ай бұрын
@@Dsa_kabaap
@trailblazer555
@trailblazer555 7 ай бұрын
Today's Leetcode Problem of the Day!!!
@data-fi4hl
@data-fi4hl 3 ай бұрын
did this question on my own by learning from previous lecture!! thanks striver bhaiya
@anubhavpal1071
@anubhavpal1071 2 ай бұрын
Bro u r goated, I was able to solve the problem without looking at the solution thanks to you covering all patterns in the previous problems. Your last few vids helped me in understanding pattern 2 and 3 perfectly.
@AdityaMaurya-dw3od
@AdityaMaurya-dw3od 3 ай бұрын
Did this question on my own! Feeling so good. The previous lectures helped me
@RoshanPathak-i4l
@RoshanPathak-i4l 4 ай бұрын
Hi Striver, I think few corrections required, but I think you have already addressed it, adding in the java reference code, but bro you are awesome. class Solution { public int subarraysWithKDistinct(int[] nums, int k) { return countSubArraysWithGoal(nums, k) - countSubArraysWithGoal(nums, k-1); } private int countSubArraysWithGoal(int[] nums, int goal){ if(goal
@HimanshuYadav-fg8sm
@HimanshuYadav-fg8sm 7 ай бұрын
Sir There are 2 mistakes thre should be if(map.size()>k) and l++ in the place of l=l-1.
@stith_pragya
@stith_pragya 6 ай бұрын
Understood.............Thank You So Much for this wonderful video...........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻
@stith_pragya
@stith_pragya 6 ай бұрын
Understood.....Thank You So Much for this wonderful video..........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻
@devanshsingh2
@devanshsingh2 4 ай бұрын
Solved on my own thanks to you!
@AbhishekKumar-vu3cp
@AbhishekKumar-vu3cp Ай бұрын
i solved this on my own Thanks Striver
@Cool96267
@Cool96267 6 ай бұрын
Thankyou so much Striver for all you efforts throughout in delivering us so much valuable content. Any student / working professional can now be able to transition their career without paying money for courses. Would also like your insights on the point : While preparing for interviews most of the aspirants are going through the videos solely and solving the question after completely watching the video. And also are feeling lazy trying to solve the question on our own. What is the best way to complete any topic without being lazy and how should an aspirant approach any topic/playlist?
@RajanKumar-vf7op
@RajanKumar-vf7op 8 ай бұрын
class Solution { public: int helper(vector& nums, int k) { int left = 0, right = 0; map map; int cnt = 0; while(right < nums.size()) { map[nums[right]]++; while(map.size() > k) { map[nums[left]]--; if(map[nums[left]] == 0) map.erase(nums[left]); left++; } cnt += right - left + 1; right++; } return cnt; } int subarraysWithKDistinct(vector& nums, int k) { return helper(nums, k) - helper(nums, k - 1); } };
@abhishekrao4853
@abhishekrao4853 7 ай бұрын
thanks bro
@harshsingh357
@harshsingh357 7 ай бұрын
Nice
@torishi82
@torishi82 6 ай бұрын
Understood. Completed full playlist.
@shreyxnsh.14
@shreyxnsh.14 Ай бұрын
super easy if you have watched the previous videos: class Solution { public: int subarraysWithKDistinct(vector& nums, int k) { //optimal: (atmost k different) - (atmost k-1 different) int count1 = 0, count2 = 0, l = 0, r = 0; unordered_map mpp; while(r < nums.size()){ mpp[nums[r]]++; if(mpp.size() > k){ while(mpp.size() > k){ mpp[nums[l]]--; if(mpp[nums[l]]==0) mpp.erase(nums[l]); l++; } } if(mpp.size() k-1){ while(mpp.size() > k-1){ mpp[nums[l]]--; if(mpp[nums[l]]==0) mpp.erase(nums[l]); l++; } } if(mpp.size()
@Krishna-ti8ys
@Krishna-ti8ys 7 ай бұрын
Thank you so much bhaiya. I learned a lot from you. Please make a playlist on greedy as well if possible.
@hareshnayak7302
@hareshnayak7302 6 ай бұрын
Undeerstood,Thanks Striver for this amazing video.
@knowthrvdo
@knowthrvdo 5 ай бұрын
00:04 Count the number of subarrays with exactly K different integers. 02:26 Use two pointers and a sliding window to find subarrays with k different integers 04:52 Algorithm for counting total number of subarrays with k different integers 07:12 Using count and frequency to determine valid windows 09:43 Using sliding window to find subarrays with k different integers. 12:16 Creating valid subarrays using 2 Pointers and Sliding Window approach 14:37 Using sliding window to find subarrays with k different integers 17:03 Using the sliding window technique to solve for subarrays with k different integers. 19:17 Discussion on time and space complexity with the use of map data structure. Crafted by Merlin AI.
@wilhelmrudolphfittig3577
@wilhelmrudolphfittig3577 5 ай бұрын
understood ! L9,L10,L11 are the same.
@VarunPattikonda
@VarunPattikonda 15 күн бұрын
Point to remember: when you are not sure which pointer to move,then try to find different approach like striver used in previous 3 videos
@varrnitjaiswal1484
@varrnitjaiswal1484 7 ай бұрын
Bro can predict future. Daily problem solvers can relate.
@kenil98
@kenil98 7 ай бұрын
@taqimustafa7665
@taqimustafa7665 7 ай бұрын
hahaha yes.i had seen the videoes before this and thought i watch the playlist from this video today,saw daily question,was easy to solve from the previous videoes knowledge and now when i open this playlist again,i see this video hahah
@rushidesai2836
@rushidesai2836 3 ай бұрын
This is a gold question
@techmatein
@techmatein 3 ай бұрын
solved hard question on my own by applying the previous questions logic
@codeman3828
@codeman3828 7 ай бұрын
Was able to solve by myself. Thanks
@ashishsinghNITR
@ashishsinghNITR 8 ай бұрын
Hii striver, you are wonderful for helping millions of peoples with your knowledge. ❤❤
@siddharthsharma7938
@siddharthsharma7938 Ай бұрын
solved it on my own!
@harsh2518
@harsh2518 Ай бұрын
this problem be like : Am I a joke to you 😂
@sksanoyarali1067
@sksanoyarali1067 4 ай бұрын
class Solution { int subarraywithlessthankequaltok(vector& nums, int k){ int n=nums.size(); int l=0,r=0,cnt=0; map mpp; while(rk){ mpp[nums[l]]--; if(mpp[nums[l]]==0){ mpp.erase(nums[l]); } l++; } cnt=cnt+(r-l+1); r++; } return cnt; } public: int subarraysWithKDistinct(vector& nums, int k) { return subarraywithlessthankequaltok(nums,k)-subarraywithlessthankequaltok(nums,k-1); } };
@vinaykumarratnala5832
@vinaykumarratnala5832 3 ай бұрын
Solved before watching the video
@UtkarshWasHereBeforeYou
@UtkarshWasHereBeforeYou Ай бұрын
Did it myself, But I'm sure it is because i was in the flow of thinking in the sliding window approach, Wouldn't be able to do it if it was randomly thrown at me,
@abhisheksinghdangi5027
@abhisheksinghdangi5027 7 ай бұрын
Todays lc potd
@Mohit_Q
@Mohit_Q 7 ай бұрын
wowwww mazeeee
@priyanshkumar17
@priyanshkumar17 7 ай бұрын
yeah!!!
@yashgaikwad6256
@yashgaikwad6256 7 ай бұрын
yahh!
@VinayQ-
@VinayQ- Ай бұрын
I think the code sippet liitle bit wrong while(mpp.size() > k){ l=l+1 }
@N1903-q9t
@N1903-q9t 7 ай бұрын
striver can you please do problems on in how many ways an array can be splitted based on the given condition
@DeadPoolx1712
@DeadPoolx1712 Ай бұрын
UNDERSTOOD;
@117_mainakpaul2
@117_mainakpaul2 Ай бұрын
Can we use hashset instead of hashmap ??
@anantsaxena5454
@anantsaxena5454 5 ай бұрын
Solved
@RadheShyam33455
@RadheShyam33455 2 ай бұрын
Hey can anyone explain me why space complexity is O(n) I think it should be O(k+1) because as soon as size exceeds 2*(k+1) we are shrinking the window .Please rectify me if I am wrong 😊
@niteshkumarjha7914
@niteshkumarjha7914 7 ай бұрын
here is java solution code class Solution { public int subarraysWithKDistinct(int[] nums, int k) { int subK = helper(nums,k); int sub = helper(nums,k-1); return subK-sub; } private int helper(int nums[], int k){ HashMap map = new HashMap(); int left=0; int right=0; int count=0; while(rightk){ map.put(nums[left],map.get(nums[left])-1); if(map.get(nums[left])==0){ map.remove(nums[left]); } left++; } count = count+ right-left+1; right++; } return count; } }
@jitinroy2246
@jitinroy2246 Ай бұрын
in helper function, i think you missed the edge case when k is negative. if(k < 0){ return 0; }
@oyeesharme
@oyeesharme 3 ай бұрын
thanks bhaiya
@HimanshuYadav-fg8sm
@HimanshuYadav-fg8sm 7 ай бұрын
Same code in java class Solution { public int subarraysWithKDistinct(int[] nums, int k) { return fun(nums,k)-fun(nums,k-1); } int fun(int []nums,int k){ Map frequencyMap = new HashMap(); int left = 0, right = 0, count = 0; while (right < nums.length) { frequencyMap.put(nums[right], frequencyMap.getOrDefault(nums[right], 0) + 1); while (frequencyMap.size() > k) { frequencyMap.put(nums[left], frequencyMap.get(nums[left]) - 1); if (frequencyMap.get(nums[left]) == 0) { frequencyMap.remove(nums[left]); } left++; } count=count+(right-left+1); right++; } return count; } }
@SHIVAMOJHA21
@SHIVAMOJHA21 16 күн бұрын
SUPERHERO
@aayushgakhar3525
@aayushgakhar3525 3 ай бұрын
gives tle for string w exactly k diff chars
@foziezzz1250
@foziezzz1250 5 ай бұрын
How can we do this in O(N) time instead of O(2N) time ..??❓ 🤔🤔
@sid_ofc17
@sid_ofc17 4 ай бұрын
with sliding window i dont think so
@ayushmishra6575
@ayushmishra6575 2 ай бұрын
We can use 3 pointer approach for that
@akworld2739
@akworld2739 6 ай бұрын
mujhse ek question bhi nhi ho rha sliding window ka bus brute force soch pa rha hu lag rha hai coding mere bas ki bat nhi
@raushankumargupta7018
@raushankumargupta7018 6 ай бұрын
Striver❤
@karthik-varma-1579
@karthik-varma-1579 Ай бұрын
class Solution { public int subarraysWithKDistinct(int[] nums, int k) { return subArraysLessThanEqualToK(nums,k)-subArraysLessThanEqualToK(nums,k-1); } public int subArraysLessThanEqualToK(int[] nums,int k){ int l=0,r=0,count=0; HashMap hm = new HashMap(); while(r k){ int rm = nums[l]; hm.put(rm,hm.get(rm)-1); if(hm.get(rm) == 0){ hm.remove(rm); } l++; } count += (r-l); r++; } return count; } }
@shivangitiwari2485
@shivangitiwari2485 7 ай бұрын
Understood
@tanujaSangwan
@tanujaSangwan 2 ай бұрын
This is similar to lats 2 questions
@ManishKumar-dk8hl
@ManishKumar-dk8hl 7 ай бұрын
class Solution { public int help(int[] arr, int k) { int l = 0; int r = 0; int cnt = 0; HashMap mpp = new HashMap(); while (r < arr.length) { mpp.put(arr[r],mpp.getOrDefault(arr[r],0)+1); while(mpp.size()>k){ mpp.put(arr[l],mpp.get(arr[l])-1); if(mpp.get(arr[l])==0){ mpp.remove(arr[l]); } l++;} cnt=cnt+r-l+1; r++; } return cnt; } public int subarraysWithKDistinct(int[] arr, int k) { return help(arr,k)-help(arr,k-1); } }
@md.sabbirahmed4482
@md.sabbirahmed4482 8 ай бұрын
Sir please add OPPS playlist.
@akworld2739
@akworld2739 6 ай бұрын
ok opps
@prasannavenkkatesh1192
@prasannavenkkatesh1192 6 ай бұрын
Why cant we use set?
@sirat_e_islam
@sirat_e_islam 5 ай бұрын
We need number and its freq set stores single thing not key value pairs
@angeldeveloper
@angeldeveloper 8 ай бұрын
🎉🎉
@imdavinder
@imdavinder 7 ай бұрын
I have still the confusion like How (
@teja1184
@teja1184 7 ай бұрын
when sliding window shrinking is happening then at that time we will use k-1 probably this case arises when there is problems ask us to count. Even in the above problem also when we took up to k then we missed few subarrays so at that time we take k-1 . so by subtracting k and (k-1) we get the exact answer
@diwakaranagrawal4673
@diwakaranagrawal4673 7 ай бұрын
for example, k=3 if we take (i) and for (ii) so to find for k==3, if we subtract (i) - (ii) => x=3=k hope this helps.
@imdavinder
@imdavinder 7 ай бұрын
@@diwakaranagrawal4673 Thank you for the crystal clear explanation !
@TarunKumar-cn6in
@TarunKumar-cn6in 4 ай бұрын
@@diwakaranagrawal4673 we can also do it by (
@THOSHI-cn6hg
@THOSHI-cn6hg 2 ай бұрын
ok]
@leslysujith8032
@leslysujith8032 6 ай бұрын
i im leithls aka the lethal sujith
@smitasingh8942
@smitasingh8942 3 ай бұрын
can someone please correct my code class Solution { public: int subarraysWithKDistinct(vector& nums, int k) { int l=0; int r=0; int cnt=0; map m; while(rk){ m[nums[l]]--; if(m[nums[l]]==0)m.erase(nums[l]); l++; } if(m.size()==k){ cnt=cnt+(r-l+1); } r++; } return cnt; } };
@ChillCoderForever
@ChillCoderForever 8 ай бұрын
Me first 😂😂😂
@dayashankarlakhotia4943
@dayashankarlakhotia4943 8 ай бұрын
public int subarraysWithKDistinct(int[]nums,int k){ return atMostK(nums,k)-atMostK(nums,k-1); } private int atMostK(int[]nums,int k){ int ans=0;int[]cnt=new int[nums.length+1]; for(int l=0,r=0;r
@shreshthkushwaha
@shreshthkushwaha 7 ай бұрын
bruh
@pranjuljaiswal1974
@pranjuljaiswal1974 23 күн бұрын
check this out int n=arr.length,l=0,r=0,count=0; HashMap map = new HashMap(); while(r k){ map.put(arr[l],map.getOrDefault(arr[l],0)-1); if(map.get(arr[l]) == 0) map.remove(arr[l]); l++; } count+=(r-l+1); r++; } return count;
@SitaRam-m1i
@SitaRam-m1i 27 күн бұрын
Understood
L12. Minimum Window Substring | 2 Pointers and Sliding Window Playlist
27:06
Каха и лужа  #непосредственнокаха
00:15
ТВОИ РОДИТЕЛИ И ЧЕЛОВЕК ПАУК 😂#shorts
00:59
BATEK_OFFICIAL
Рет қаралды 6 МЛН
How I would learn Leetcode if I could start over
18:03
NeetCodeIO
Рет қаралды 687 М.
L9. Binary Subarrays With Sum | 2 Pointers and Sliding Window Playlist
20:27
Subarray Sum Equals K - Prefix Sums - Leetcode 560 - Python
15:19
Каха и лужа  #непосредственнокаха
00:15